type Sampler{D}
	dist::D
  regen::Function
	σᵥ²::Float64
	dt::Float64
	τh::Float64
	τl::Float64
  M::Matrix{Float64}
  B::Matrix{Float64}
	u::Vector{Float64}
	v::Vector{Float64}
  L::Float64
end

Sampler(dist; 
	    σᵥ²::Float64=1.0, 
	    δt::Float64=0.01,
	    τh::Float64=10.,
	    τl::Float64=150.,
      regen::Function=regen_contrast)= begin
  u = zeros(dim)
  u[1] = 1.
  v = zeros(dim)
  B = Float64[1.*(i==j) + 0.01*abs(randn())*(i>=2 && j >= 2)*((i==(j+1)) + ((i+1)==j)) for i=1:(n+1), j=1:(n+1)]
  #m = eye(n) + off_diag_coef*rand(n, n)
  #invM1 = max(zeros(n, n), (τh/τl)*dist.invC/(1-τh/τl), -dist.invC/(1-τh/τl))
  if τh == 150.
    M = zeros(n+1, n+1)
    B = zeros(n+1, n+1)
  else
    M = eye(n+1)
    M[1:n, 1:n] = inv(dist.AᵀA)
    M[M.<0] = 0.
    B = Float64[1.*(i==j) + 0.01*abs(randn())*(i>=2 && j >= 2)*((i==(j+1)) + ((i+1)==j)) for i=1:(n+1), j=1:(n+1)]
  end
  #    invM = max(zeros(n, n), (τh/τl)*dist.invC/(1-τh/τl), -dist.invC/(1-τh/τl))
  #    invM = invM + diagm(1-diag(invM))
  #    #invM = [1 zeros(1, n); zeros(n, 1) m*m']
  #    invM = [1 zeros(1, n); zeros(n, 1) invM]
  #    @assert isposdef(invM)
  #    @assert all(invM .>= -1E-10)
  #    @assert all((1/τh-1/τl)*invM[2:end, 2:end] - dist.invC/τl .>= -1E-10)
  #    @assert all((1/τh+1/τl)*invM[2:end, 2:end] + dist.invC/τh .>= -1E-10)
  #end
	Sampler(dist, regen, σᵥ², δt, τh, τl, M, B, u, v, 0.)
end
