source("~/Dropbox/libs/Rtikz.R")
library(ggplot2)
library(gridExtra)
library(reshape)

#linesize=0.5
#
#them <- theme_classic() +
#  theme(plot.title=element_text(hjust=-0.6, vjust=2.9)) +
#  #theme(plot.title=element_text(hjust=-0.1)) +
#  theme(line=element_line(size=linesize)) +
#  #theme(text=element_text(size=15)) +
#  theme(axis.text=element_text(size=12)) +
#  theme(legend.key=element_blank()) +
#  theme(axis.line.x=element_line(colour="black")) +
#  theme(axis.line.y=element_line(colour="black"))

data <- data.frame(read.csv("ei_balance", colClass="numeric"))
#data$v <- data$v/5

us <- data$u/sqrt(var(data$u))
vs <- data$v/sqrt(var(data$v))

#abu <- expression(paste(symbol("\341"), u(t), symbol("\361")))
#abv <- expression(paste(symbol("\341"), v(t), symbol("\361")))
#
#abu_t <- expression(paste(symbol("\341"), u, symbol("\361"), " (a.u.)"))
#abv_t <- expression(paste(symbol("\341"), v, symbol("\361"), " (a.u.)"))

#p <- ggplot(data, aes(u, v, colour=t)) +
#    scale_x_continuous("Avg. excit. (a.u.)") +
#    scale_y_continuous("Avg. inhib. (a.u.)") +
#    geom_path(size=linesize, lineend="round") +
#    theme_classic() + 
#    scale_colour_continuous("t (ms)", high="red", low="blue") +
#    them #+ ggtitle('A')

data <- melt(data, id=c("t"), measured=c("u", "v"))
data$variable <- as.factor(data$variable)
#data$variable = factor(data$variable,levels(data$variable)[c(2, 1)])

B <- ggplot(data, aes(x=t-1000, y=value, colour=variable)) +
    scale_x_continuous("$t$ (ms)", limits=c(0, 200), breaks=c(0, 100, 200)) +
    #scale_y_continuous("Average membrane\npotential (a.u.)") +
    #scale_y_continuous(expression(paste(symbol("\341"), u(t), symbol("\361"), ", ", symbol("\341"), v(t), symbol("\361"), " (a.u.)")), limits=c(-0.5, 1.5)) +
    scale_y_continuous("Input (normalized)", breaks=c(0, 1)) +
    coord_cartesian(ylim=c(-0.5, 1.5)) +
    scale_colour_discrete("", labels=c("Excitatory", "Inhibitory")) +
    #scale_colour_manual("", values=c("blue", "red"), labels=c(abv, abu)) +
    geom_line(size=linesize) +

    them + theme(legend.position=c(0.6, 0.9))
B <- let(B, "B")

A <- ggplot(data.frame(read.csv("ei_balance_stationary", colClasses="numeric")), aes(x=u, y=v)) +
    geom_point() +
    scale_x_continuous("Avg. excit. (a.u.) ", limits=c(-0.5, 0.5), breaks=c(-0.5, 0., 0.5)) +
    scale_y_continuous("Avg. inhib. (a.u.)", limits=c(-0.5, 0.5), breaks=c(-0.5, 0., 0.5)) +
    them
A <- let(A, "A")

ccf_obj <- ccf(us, vs, plot=FALSE, lag.max=100)
ccf_df  <- data.frame(lag=ccf_obj$lag, cc=ccf_obj$acf)
C <- ggplot(ccf_df, aes(x=lag, y=cc)) +
    geom_line(size=linesize) +
    scale_x_continuous("$t$ (ms)", breaks=c(-100, 0, 100)) +
    scale_y_continuous("Cross corr. (a.u.)", limits=c(-1, 1), breaks=c(-1, 0, 1)) +
    geom_vline(xintercept=0, colour="black", linetype="dotted") +
    them
C <- let(C, "C")

#pdf("ei_balance.pdf", width=10, height=3)
#grid.arrange(p, q, r, ncol=3, widths=c(1, 1, 0.7))
tikz("ei_balance.tex", width=pagewidth, height=pagewidth/3)
grid.arrange(A, B, C, ncol=3)
dev.off()

