library(ggplot2)
library(gridExtra)

them <- theme_classic() +
        theme(line=element_blank(),
              plot.title=element_text(hjust=-0.1, vjust=1),
              legend.key=element_blank(),
              axis.text=element_blank())

data <- data.frame(read.csv("filters", colClasses=c("numeric", "numeric", "numeric")))

p <- ggplot(subset(data), aes(x=x, y=y, fill=filter)) +
    geom_raster() +
    scale_x_continuous("") +
    scale_y_continuous("") +
    scale_fill_continuous(low="black", high="white") +
    them + theme(legend.position="none") 

ggsave("filters.pdf", width=5, height=3)
