#!/usr/bin/julia

macro R_str(s)
    s
end

const filename = ARGS[1][1:(end-4)]

const standAlone = string(
R"\documentclass[10pt]{article}
\usepackage{tikz}
\usepackage{amsmath}

\usepackage[active,tightpage,psfixbb]{preview}

\PreviewEnvironment{pgfpicture}

\setlength\PreviewBorder{0pt}
\begin{document}

", readall("$filename.tex"), R"\end{document}")

output_filename = "$(filename)_standAlone.tex"

f = open(output_filename, "w+")
write(f, standAlone)
close(f)

run(`pdflatex -batch -jobname $filename $output_filename`)

run(`latexmk -c`)
run(`rm $output_filename`)
